using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Ivi.Driver;
using Ivi.RFSigGen;
using RohdeSchwarz.RsRFSigGen;

//Before you can use this example, download IVI shared components and IVI.NET shared components from:
//http://www.ivifoundation.org/shared_components/Default.aspx

//instrument driver installation files including RohdeSchwarz.RsRFSigGen.Fx40.dll are located in:
//c:\Program Files\Rohde-Schwarz\RsRfSigGen\

namespace RsRFSigGen_3GPP_Example
{
    public partial class RsRFSigGen_3GPP_Example : Form
    {
        RsRFSigGen driver = null;

        public RsRFSigGen_3GPP_Example()
        {
            InitializeComponent();
        }

        private void RsRFSigGen_3GPP_Example_Load(object sender, EventArgs e)
        {
            TestModel.SelectedIndex = 0;
        }

        private void ExitButton_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Are you sure you want to exit?", "Exit?", MessageBoxButtons.YesNo) == DialogResult.Yes)
                Close();
        }

        private void Apply_Click(object sender, EventArgs e)
        {
            //int path = 1;
            string path = "A";
            try
            {
                UseWaitCursor = true;
                System.Windows.Forms.Cursor.Current = Cursors.WaitCursor;
                if (driver==null)
                    driver = new RsRFSigGen(ResourceDescriptor.Text, IDQuery.Checked, ResetDevice.Checked);

                driver.Path[path].BasebandSignal.W3GPPFDD.W3GPPConfigureBasestationUserEquipment.W3GPPTestSetupsModels.TestModelBS = TestModel.Text;
                driver.Path[path].BasebandSignal.W3GPPFDD.W3GPPFilterClippingARBSettings.SequenceLength = int.Parse(SequenceLength.Text);
                driver.Path[path].BasebandSignal.W3GPPFDD.Enabled = WCDMAState.Checked;
                driver.RFAnalogModulation.Path[path].RFLevelSettings.Amplitude = Decimal.ToDouble(RFLevel.Value);
                driver.RFAnalogModulation.Path[path].RFFrequencySettings.Frequency = Decimal.ToDouble(RFFreq.Value);
                driver.RFAnalogModulation.Path[path].OutputEnabled = RFState.Checked;
                
                //m_Instrument.EventStatusEnable(1);
                //m_Instrument.ClearStatus();                
                //m_Instrument.SetW3GPPTestModelBS(path, TestModel.SelectedIndex);
                //m_Instrument.SetW3GPPSequenceLengthARB(path, int.Parse(SequenceLength.Text));
                //m_Instrument.SetW3GPPFDDState(1, WCDMAState.Checked);
                /*
                m_Instrument.OperationComplete();
                int sync = 0;
                do
                {
                    m_Instrument.StatusByteQuery(out sync);
                    System.Threading.Thread.Sleep(100);
                } while (sync == 0);
                */

                //m_Instrument.SetRFAmplitude(path, Decimal.ToDouble(RFLevel.Value));
                //m_Instrument.SetRFFrequency(path, Decimal.ToDouble(RFFreq.Value));
                //m_Instrument.SetOutputState(path, RFState.Checked);
            }
            catch (Exception ex)
            {
                String message;

                message = "Instrument Status Error: ";
                message += ex.Message;
                MessageBox.Show(message);
            }
            System.Windows.Forms.Cursor.Current = Cursors.Arrow;
            UseWaitCursor = false;
        }

     }
}